"use strict";
/**
 * Extend function
 * ================
 *
 * Function used to push a bunch of values into an array at once.
 * Freely inspired by @Yomguithereal/helpers/extend.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.extend = void 0;
/**
 * Extends the target array with the given values.
 *
 * @param  {array} array  - Target array.
 * @param  {array} values - A set of the values to add.
 */
function extend(array, values) {
    var l2 = values.size;
    if (l2 === 0)
        return;
    var l1 = array.length;
    array.length += l2;
    var i = 0;
    values.forEach(function (value) {
        array[l1 + i] = value;
        i++;
    });
}
exports.extend = extend;
